#include <bits/stdc++.h>
using namespace std;

int n;
long long o,a,b,ab;
string grupe[10005];
long long jedinice[10005];
int matrica[10001][10001]={0};
int main()
{
    cin>>n;
    cin>>o>>a>>b>>ab;
    for(int i=0;i<n;i++)
        cin>>grupe[i]>>jedinice[i];

    for(int i=0;i<n;i++)
    {
        if(grupe[i]=="O" && jedinice[i]>o)
            {
                cout<<"nemoguce";
                return 0;
            }
        else if(grupe[i]=="O"&& jedinice[i]<=o)
        {
            matrica[i][0]=jedinice[i];
            o-=jedinice[i];
        }

        if(grupe[i]=="A"&&jedinice[i]>(o+a))
            {
                cout<<"nemoguce";
                return 0;
            }
        else if(grupe[i]=="A"&&jedinice[i]<=(o+a))
        {
            for(int j=0;j<jedinice[i];j++)
            {
                if(a)
                {
                    matrica[i][1]++;
                    a--;
                }
                else
                {
                    matrica[i][0]++;
                    o--;
                }
            }
        }

        if(grupe[i]=="B"&&jedinice[i]>(o+b))
            {
                cout<<"nemoguce";
                return 0;
            }
        else if(grupe[i]=="B"&&jedinice[i]<=(o+b))
        {
            for(int j=0;j<jedinice[i];j++)
            {
                if(b)
                {
                    matrica[i][2]++;
                    b--;
                }
                else
                {
                    matrica[i][0]++;
                    o--;
                }
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        if(grupe[i]=="AB"&&jedinice[i]>(o+a+b+ab))
            {
                cout<<"nemoguce";
                return 0;
            }
        else if(grupe[i]=="AB"&&jedinice[i]<=(o+a+b+ab))
        {
            for(int j=0;j<jedinice[i];j++)
            {
                if(ab)
                {
                    matrica[i][3]++;
                    ab--;
                }
                else if(o)
                {
                    matrica[i][0]++;
                    o--;
                }
                else if(a)
                {
                    matrica[i][1]++;
                    a--;
                }
                else if(b)
                {
                    matrica[i][2]++;
                    b--;
                }
            }
        }
    }
    cout<<"moguce"<<"\n";
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<4;j++)
        {
            cout<<matrica[i][j]<<" ";
        }
        cout<<"\n";
    }
    return 0;
}